﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/user_input_handler_registry.php';
class SmartEntryHandler
    implements UserInputHandler
{
    private $tv;

    public function __construct($tv)
    {
        $this->tv = $tv;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_handler_id()
    {
        return 'entry';
    }
	
    public function handle_user_input(&$user_input, &$plugin_cookies){
		$jsd = SmartConfig::hlsclient();
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		$start_tv = (HD::get_item('start_tv') !='') ? HD::get_item('start_tv') : 0;
		
		if ((isset($user_input->control_id))&&($user_input->control_id == 'omega_key')){
			if (($user_input->omega_key == false)&&(strlen($user_input->omega_key) != 4))
				return UserInputHandlerRegistry::create_action($this, 'add_key');
			$jsd = SmartConfig::hlsclient($user_input->omega_key);
			if (!isset($jsd->success)){
				$trashed = '';	
				if (isset($jsd->trashed->type))
					$trashed = $jsd->trashed->type;				
				throw new DuneException(
					'HTTP network error', 0,
					ActionFactory::show_error(
					true,
					'Error: '. $jsd->error_msg .' - '. $jsd->error,
					array(
						$jsd->message->name,
						$jsd->message->phone,
						$trashed))
				);
			}
			if ($start_tv == 1)
				return ActionFactory::tv_play();
			else
				return ActionFactory::open_folder();
		}
		else if ((isset($user_input->control_id))&&($user_input->control_id == 'add_key')){
			$defs = array();
			$omega_key = 'Четерехзначный код';
			ControlFactory::add_multiline_label($defs, '', "Код активации (получить в личном кабинете cabinet.mynet.ua)", 6);
			ControlFactory::add_text_field($defs,
				$handler=null, $add_params=null,
				'omega_key', '',
				$omega_key, 0, 0, 0, 0, 1050);
			ControlFactory::add_smart_label($defs,"", '<text dy="7" size="small"> Нажмите </text><icon>gui_skin://special_icons/controls_button_blue.aai</icon><text dy="7" size="small"> для вызова экранной клавиатуры</text>');
			$action = UserInputHandlerRegistry::create_action($this, 'omega_key');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'omega_key', 'Применить', 350, $action);
			return ActionFactory::show_dialog('Введите код', $defs, true, 1100, $attrs);
		}
		else if ((isset($user_input->control_id))&&($user_input->control_id == 'do_hard_reset')){
			return shell_exec('reboot');
		}
		else if ((isset($user_input->control_id))&&($user_input->control_id == 'do_setup')){
			return ActionFactory::open_folder(SmartSetupScreen::get_media_url_str(),'Настройки');
		}
		else if ((isset($user_input->control_id))&&($user_input->control_id == 'power_off')){
			return shell_exec('echo A15EBF00 > /proc/ir/button');
		}
		else if ($user_input->handler_id == 'entry'){
			$jsd = SmartConfig::hlsclient();
			$this->tv->unload_channels();
			if (isset($jsd->success)){
				if ($start_tv == 1)
					return ActionFactory::tv_play();
				else
					return ActionFactory::open_folder();
			}else
				return UserInputHandlerRegistry::create_action($this, 'add_key');
			
		}

    }
}

///////////////////////////////////////////////////////////////////////////
?>
