<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';
require_once 'Smart_channel.php';
///////////////////////////////////////////////////////////////////////////

class SmartTv extends AbstractTv
{
    public function __construct(){
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            SmartConfig::TV_FAVORITES_SUPPORTED,
            true);
    }

    public function get_fav_icon_url(){
        return SmartConfig::FAV_CHANNEL_GROUP_ICON_PATH;
    }
	public $jsdArr = false;
    ///////////////////////////////////////////////////////////////////////
	private static function get_icon_path($_id, $icon_uhd){
		if (file_exists(DuneSystem::$properties['install_dir_path'] . "/logo/$_id.png"))
			$icon_path = "plugin_file://logo/$_id.png";
		else{
			$doc =  file_get_contents($icon_uhd);
			file_put_contents (DuneSystem::$properties['install_dir_path'] . "/logo/$_id.png", $doc);
			$icon_path = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $icon_uhd;
		}
		return $icon_path; 
	}
    ///////////////////////////////////////////////////////////////////////

    protected function load_channels(&$plugin_cookies){
		$this->jsdArr = SmartConfig::hlsclient();
		$opts = array(
			"http" => array(
				"method" => "GET",
				"header" => "token: " . $this->jsdArr->success->token
			)
		);
		$context = stream_context_create($opts);
		$jsd = json_decode (file_get_contents($this->jsdArr->success->playlist_url, false, $context));
        $this->channels = new HashedArray();
        $this->groups = new HashedArray();
        $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    SmartConfig::FAV_CHANNEL_GROUP_CAPTION,
                    SmartConfig::FAV_CHANNEL_GROUP_ICON_PATH));
		
        $this->groups->put(
            new AllChannelsGroup(
                $this,
                SmartConfig::ALL_CHANNEL_GROUP_CAPTION,
                SmartConfig::ALL_CHANNEL_GROUP_ICON_PATH));
				
		
        foreach ($jsd as $v){
			$is_protected = 0;
			if ($v->ganre->id == 21)
				$is_protected = 1;
			$arc = 0;
			if ($v->active == 1)
				$channel =
					new SmartChannel(
                    strval($v->id),
                    strval($v->name),
                    strval(self::get_icon_path($v->id, $v->logo)),
                    strval($v->link),
                    intval($v->key),
                    intval(3),
                    intval(3),
					$is_protected,
					$arc
					);

			if (!($this->groups->has($v->ganre->id))){
				$this->groups->put(
					new DefaultGroup(
					strval($v->ganre->id),
					strval($v->ganre->name),
					self::get_icon_path('ganre_'.$v->ganre->id, $v->ganre->icon->uhd)));
			}	
			$this->channels->put($channel);
			$group = $this->groups->get($v->ganre->id);
			$channel->add_group($group);
			$group->add_channel($channel);
        }

        if (SmartConfig::CHANNEL_SORT_FUNC_CB != null)
            $this->channels->usort(SmartConfig::CHANNEL_SORT_FUNC_CB);
    }

    ///////////////////////////////////////////////////////////////////////////
	public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies){
		$url = $this->get_channel($channel_id)->get_streaming_url();
		$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';
        $nado = $this->get_channel($channel_id)->is_protected();
		if ($nado)
			if ($protect_code !== $pin)  
				return "http://mp4://dune-club.info/plugins/update/1.mp4";
		return $url;
	}
    ///////////////////////////////////////////////////////////////////////////

    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies){
        $epg_leng = (HD::get_item('epg_leng') !='') ? HD::get_item('epg_leng') : 'uk';
		$datediff = $day_start_ts - strtotime(date("m.d.y"));
		$day = round($datediff / (60 * 60 * 24));
		echo $this->jsdArr->success->epg_v3 . $this->jsdArr->success->playlist . "/$channel_id/channel.json?lang=$epg_leng&from=$day&to=$day&img_q=uhd";
		$jsd =json_decode (file_get_contents($this->jsdArr->success->epg_v3 . $this->jsdArr->success->playlist . "/$channel_id/channel.json?lang=$epg_leng&from=$day&to=$day&img_q=uhd"));
        $epg = array();
        foreach ($jsd as $epg_item){
            $epg[] =
                new DefaultEpgItem(
                    strval($epg_item->title),
                    strval(''),
                    intval($epg_item->start_at),
                    intval($epg_item->stop_at));
        }
        return
            new EpgIterator(
                $epg,
                $day_start_ts,
                $day_start_ts + 86400);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
